# Plan
Here's a checklist of my immediate plans for the future. If you have an idea for a feature, feel free to make an issue.

## v1.3.2
* [x] Improve forcefield.
	* [x] Get simple lightning working.
	* [ ] ~Have the lightning rotate as the player rotates.~
	* [x] Improve the code.
	* [x] Animate the lightning.
	* [x] Improve the animation.
	* [x] Change the render order.
	* [x] Have the lightning loop around.
		* [x] Get started.
		* [x] Move the endpoints around.
	* [x] Pulsing effects.
		* [x] Add a pulsing effect to the radial gradient.
		* [x] Add a pulsing effect to the lightning.
		* [x] Add more detail to the gradient pulsing.
	* [x] Have line width be in forcefield coordinates (world coordinates scaled by forcefield size), which will make the forcefield look the same regardless of world/pixel coordinate.
		* [x] Get very basic solution working.
		* [x] Improve it (maybe).
		* [ ] ~Improve it even more (maybe).~
	* [x] Even the distances between adjacent endpoints.
	* [x] Ensure the lightning pulse effect wraps around nicely.
	* [x] Update use of gl_VertexID.
	* [x] Possibly add a gradient to the lightning (gradient direction perpendicular to line direction), though that likely is excessive.
	* [x] Grow and shrink the forcefield, as well as fading in and out.
		* [x] Fading in.
		* [x] Growing and shrinking.
		* [x] Fix bug with instantaneous fade in when collecting forcefield while it's fading out.
	* [x] Polishes.
		* [x] Rotate the forcefield by a random amount for each instance.
		* [x] Move pulse variables to be for each instance.
		* [x] Don't update when there are no forcefields.
* [x] Bullet improvements.
	* [x] Improve bullet texture.
	* [x] Improve bullet strength tinting.
	* [x] Effects when bullets are deflected by forcefields.
		* [x] Bullet tinting.
			* [x] Get started.
			* [x] Maybe make it stronger.
			* [x] Prevent tinting for bullets that aren't deflected.
		* [x] Particle effects.
			* [x] Get started.
				* [x] Add forcefield particles to game config.
				* [x] Refactor for finding forcefield strength.
				* [x] Sanity check test to see if physics changed.
				* [x] Particles.
			* [x] Add checkbox to GUI.
			* [x] Improve their physics.
			* [x] Improve their style.
* [x] Fix bug with forcefields fading in when the player joins.
* [x] Allow disabling forcefield lightning for performance reasons.
* [x] Try and make block border gradient better when zoomed out.
	Mitigating this by decreasing the alpha when the pixel width is sufficiently small.
* [x] Remove `forcefield.ron` test config.
* [x] Update Flatpak metainfo.

## v1.4.0
* [ ] Add extension data to protocol.
* [ ] Update SERP version.
